//energyBlaster.cs

//audio
datablock AudioProfile(energyBlasterShot1Sound)
{
   filename    = "./energyBlasterShot1.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(energyBlasterChargeSound : energyBlasterShot1Sound)
{
   filename    = "./energyBlasterCharge.wav";
};

datablock ParticleData(energyBlasterbulletTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 625;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/Ring";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.9 0.4";
	colors[1]     = "0.0 0.0 0.9 0.0";
	sizes[0]      = 1;
	sizes[1]      = 1.1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(energyBlasterbulletTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "energyBlasterbulletTrailParticle";
};
//shell maybe later?
// datablock DebrisData(energyBlasterShellDebris)
// {
	// shapeFile = "./battery.dts";
	// lifetime = 2.0;
	// minSpinSpeed = -400.0;
	// maxSpinSpeed = 200.0;
	// elasticity = 0.5;
	// friction = 0.2;
	// numBounces = 3;
	// staticOnMaxBounce = true;
	// snapOnMaxBounce = false;
	// fade = true;

	// gravModifier = 2;
// };

datablock ParticleData(energyBlasterExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/ring";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.9 0.3";
	colors[1]     = "0.1 0.1 0.9 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};
datablock ParticleEmitterData(energyBlasterExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "energyBlasterExplosionParticle";

   useEmitterColors = true;
   uiName = "Energy Blaster Hit Dust";
};


datablock ParticleData(energyBlasterExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/ring";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 0.9";
	colors[1]     = "0.0 0.0 0.9 0.0";
	sizes[0]      = 1;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(energyBlasterExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "energyBlasterExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Energy Blaster Hit Flash";
};

datablock ExplosionData(energyBlasterExplosion)
{
   //explosionShape = "";
	soundProfile = "";

   lifeTimeMS = 150;

   particleEmitter = energyBlasterExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = energyBlasterExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 2;
   lightEndRadius = 2;
   lightStartColor = "0.5 0.8 0.9";
   lightEndColor = "0 0 0";
};


AddDamageType("energyBlaster",   '<bitmap:add-ons/Weapon_energyBlaster/CI_energyBlaster> %1',    '%2 <bitmap:add-ons/Weapon_energyBlaster/CI_energyBlaster> %1',0.2,1);
datablock ProjectileData(energyBlasterProjectile)
{
   projectileShapeName = "";
   directDamage        = 10;
   directDamageType    = $DamageType::energyBlaster;
   radiusDamageType    = $DamageType::energyBlaster;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 3100;
   verticalImpulse	  = 1000;
   explosion           = energyBlasterExplosion;
   particleEmitter     = energyBlasterbulletTrailEmitter;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 250;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "energyBlaster Bullet";
};

//////////
// item //
//////////
datablock ItemData(energyBlasterItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./bwzorp.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Energy Blaster";
	iconName = "./icon_energyBlaster";
	doColorShift = false;

	 // Dynamic properties defined by the scripts
	image = energyBlasterImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(energyBlasterImage)
{
   // Basic Item properties
   shapeFile = "./bwzorp.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0.06";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = energyBlasterItem;
   ammo = " ";
   projectile = energyBlasterProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1.2;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTimeout[1]  = "Charged";
	stateScript[1]					= "onReady";
	stateAllowImageChange[1]         = false;
	stateTimeoutValue[1]			= 0.2;
	stateSound[1]					= energyBlasterChargeSound;
	
	stateName[2]					= "Charged";
	stateAllowImageChange[2]		= true;
	stateTransitionOnTriggerDown[2]  = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Ready";
	stateTimeoutValue[3]            = 1.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateSound[3]					= energyBlasterShot1Sound;

};

function energyBlasterImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, plant);
	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-6")));
	Parent::onFire(%this,%obj,%slot);	
}

function energyBlasterImage::onReady(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, rotcw);
}
